/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using Aliyun.Acs.Core.Http;
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Core.Utils;
using Aliyun.Acs.Dts.Transform;
using Aliyun.Acs.Dts.Transform.V20160801;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
    public class ConfigurationSynchronizationJobRequest : RpcAcsRequest<ConfigurationSynchronizationJobResponse>
    {
        public ConfigurationSynchronizationJobRequest()
            : base("Dts", "2016-08-01", "ConfigurationSynchronizationJob")
        {
        }

		private string synchronizationJobId;

		private string destinationEndpointInstanceID;

		private string destinationEndpointInstanceType;

		private bool? initializationStructureLoad;

		private string synchronizationJobName;

		private string sourceEndpointInstanceID;

		private string sourceEndpointInstanceType;

		private string synchronizationObject;

		private bool? initializationDataLoad;

		public string SynchronizationJobId
		{
			get
			{
				return synchronizationJobId;
			}
			set	
			{
				synchronizationJobId = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationJobId", value);
			}
		}

		public string DestinationEndpointInstanceID
		{
			get
			{
				return destinationEndpointInstanceID;
			}
			set	
			{
				destinationEndpointInstanceID = value;
				DictionaryUtil.Add(QueryParameters, "DestinationEndpoint.InstanceID", value);
			}
		}

		public string DestinationEndpointInstanceType
		{
			get
			{
				return destinationEndpointInstanceType;
			}
			set	
			{
				destinationEndpointInstanceType = value;
				DictionaryUtil.Add(QueryParameters, "DestinationEndpoint.InstanceType", value);
			}
		}

		public bool? InitializationStructureLoad
		{
			get
			{
				return initializationStructureLoad;
			}
			set	
			{
				initializationStructureLoad = value;
				DictionaryUtil.Add(QueryParameters, "Initialization.StructureLoad", value.ToString());
			}
		}

		public string SynchronizationJobName
		{
			get
			{
				return synchronizationJobName;
			}
			set	
			{
				synchronizationJobName = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationJobName", value);
			}
		}

		public string SourceEndpointInstanceID
		{
			get
			{
				return sourceEndpointInstanceID;
			}
			set	
			{
				sourceEndpointInstanceID = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.InstanceID", value);
			}
		}

		public string SourceEndpointInstanceType
		{
			get
			{
				return sourceEndpointInstanceType;
			}
			set	
			{
				sourceEndpointInstanceType = value;
				DictionaryUtil.Add(QueryParameters, "SourceEndpoint.InstanceType", value);
			}
		}

		public string SynchronizationObject
		{
			get
			{
				return synchronizationObject;
			}
			set	
			{
				synchronizationObject = value;
				DictionaryUtil.Add(QueryParameters, "SynchronizationObject", value);
			}
		}

		public bool? InitializationDataLoad
		{
			get
			{
				return initializationDataLoad;
			}
			set	
			{
				initializationDataLoad = value;
				DictionaryUtil.Add(QueryParameters, "Initialization.DataLoad", value.ToString());
			}
		}

        public override ConfigurationSynchronizationJobResponse GetResponse(Core.Transform.UnmarshallerContext unmarshallerContext)
        {
            return ConfigurationSynchronizationJobResponseUnmarshaller.Unmarshall(unmarshallerContext);
        }
    }
}