/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
	public class DescribeInitializationStatusResponse : AcsResponse
	{

		private List<DescribeInitializationStatus_StructureInitializationDetail> structureInitializationDetails;

		private List<DescribeInitializationStatus_DataInitializationDetail> dataInitializationDetails;

		private List<DescribeInitializationStatus_DataSynchronizationDetail> dataSynchronizationDetails;

		public List<DescribeInitializationStatus_StructureInitializationDetail> StructureInitializationDetails
		{
			get
			{
				return structureInitializationDetails;
			}
			set	
			{
				structureInitializationDetails = value;
			}
		}

		public List<DescribeInitializationStatus_DataInitializationDetail> DataInitializationDetails
		{
			get
			{
				return dataInitializationDetails;
			}
			set	
			{
				dataInitializationDetails = value;
			}
		}

		public List<DescribeInitializationStatus_DataSynchronizationDetail> DataSynchronizationDetails
		{
			get
			{
				return dataSynchronizationDetails;
			}
			set	
			{
				dataSynchronizationDetails = value;
			}
		}

		public class DescribeInitializationStatus_StructureInitializationDetail
		{

			private string objectName;

			private string objectType;

			private string sourceOwnerDBName;

			private string destinationOwnerDBName;

			private string status;

			private string errorMessage;

			private string objectDefinition;

			private List<DescribeInitializationStatus_StructureInitializationDetail1> constraints;

			public string ObjectName
			{
				get
				{
					return objectName;
				}
				set	
				{
					objectName = value;
				}
			}

			public string ObjectType
			{
				get
				{
					return objectType;
				}
				set	
				{
					objectType = value;
				}
			}

			public string SourceOwnerDBName
			{
				get
				{
					return sourceOwnerDBName;
				}
				set	
				{
					sourceOwnerDBName = value;
				}
			}

			public string DestinationOwnerDBName
			{
				get
				{
					return destinationOwnerDBName;
				}
				set	
				{
					destinationOwnerDBName = value;
				}
			}

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}

			public string ObjectDefinition
			{
				get
				{
					return objectDefinition;
				}
				set	
				{
					objectDefinition = value;
				}
			}

			public List<DescribeInitializationStatus_StructureInitializationDetail1> Constraints
			{
				get
				{
					return constraints;
				}
				set	
				{
					constraints = value;
				}
			}

			public class DescribeInitializationStatus_StructureInitializationDetail1
			{

				private string objectName;

				private string objectType;

				private string sourceOwnerDBName;

				private string destinationOwnerDBName;

				private string status;

				private string errorMessage;

				private string objectDefinition;

				public string ObjectName
				{
					get
					{
						return objectName;
					}
					set	
					{
						objectName = value;
					}
				}

				public string ObjectType
				{
					get
					{
						return objectType;
					}
					set	
					{
						objectType = value;
					}
				}

				public string SourceOwnerDBName
				{
					get
					{
						return sourceOwnerDBName;
					}
					set	
					{
						sourceOwnerDBName = value;
					}
				}

				public string DestinationOwnerDBName
				{
					get
					{
						return destinationOwnerDBName;
					}
					set	
					{
						destinationOwnerDBName = value;
					}
				}

				public string Status
				{
					get
					{
						return status;
					}
					set	
					{
						status = value;
					}
				}

				public string ErrorMessage
				{
					get
					{
						return errorMessage;
					}
					set	
					{
						errorMessage = value;
					}
				}

				public string ObjectDefinition
				{
					get
					{
						return objectDefinition;
					}
					set	
					{
						objectDefinition = value;
					}
				}
			}
		}

		public class DescribeInitializationStatus_DataInitializationDetail
		{

			private string tableName;

			private string sourceOwnerDBName;

			private string destinationOwnerDBName;

			private string status;

			private string errorMessage;

			private string totalRowNum;

			private string finishRowNum;

			private string usedTime;

			public string TableName
			{
				get
				{
					return tableName;
				}
				set	
				{
					tableName = value;
				}
			}

			public string SourceOwnerDBName
			{
				get
				{
					return sourceOwnerDBName;
				}
				set	
				{
					sourceOwnerDBName = value;
				}
			}

			public string DestinationOwnerDBName
			{
				get
				{
					return destinationOwnerDBName;
				}
				set	
				{
					destinationOwnerDBName = value;
				}
			}

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}

			public string TotalRowNum
			{
				get
				{
					return totalRowNum;
				}
				set	
				{
					totalRowNum = value;
				}
			}

			public string FinishRowNum
			{
				get
				{
					return finishRowNum;
				}
				set	
				{
					finishRowNum = value;
				}
			}

			public string UsedTime
			{
				get
				{
					return usedTime;
				}
				set	
				{
					usedTime = value;
				}
			}
		}

		public class DescribeInitializationStatus_DataSynchronizationDetail
		{

			private string tableName;

			private string sourceOwnerDBName;

			private string destinationOwnerDBName;

			private string status;

			private string errorMessage;

			public string TableName
			{
				get
				{
					return tableName;
				}
				set	
				{
					tableName = value;
				}
			}

			public string SourceOwnerDBName
			{
				get
				{
					return sourceOwnerDBName;
				}
				set	
				{
					sourceOwnerDBName = value;
				}
			}

			public string DestinationOwnerDBName
			{
				get
				{
					return destinationOwnerDBName;
				}
				set	
				{
					destinationOwnerDBName = value;
				}
			}

			public string Status
			{
				get
				{
					return status;
				}
				set	
				{
					status = value;
				}
			}

			public string ErrorMessage
			{
				get
				{
					return errorMessage;
				}
				set	
				{
					errorMessage = value;
				}
			}
		}
	}
}