/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Model.V20160801
{
	public class DescribeSubscriptionInstanceStatusResponse : AcsResponse
	{

		private string subscriptionInstanceID;

		private string subscriptionInstanceName;

		private string payType;

		private string status;

		private string errorMessage;

		private string consumptionCheckpoint;

		private string beginTimestamp;

		private string endTimestamp;

		private string consumptionClient;

		private List<DescribeSubscriptionInstanceStatus_SynchronousObject> subscriptionObject;

		private DescribeSubscriptionInstanceStatus_SourceEndpoint sourceEndpoint;

		private DescribeSubscriptionInstanceStatus_SubscriptionDataType subscriptionDataType;

		public string SubscriptionInstanceID
		{
			get
			{
				return subscriptionInstanceID;
			}
			set	
			{
				subscriptionInstanceID = value;
			}
		}

		public string SubscriptionInstanceName
		{
			get
			{
				return subscriptionInstanceName;
			}
			set	
			{
				subscriptionInstanceName = value;
			}
		}

		public string PayType
		{
			get
			{
				return payType;
			}
			set	
			{
				payType = value;
			}
		}

		public string Status
		{
			get
			{
				return status;
			}
			set	
			{
				status = value;
			}
		}

		public string ErrorMessage
		{
			get
			{
				return errorMessage;
			}
			set	
			{
				errorMessage = value;
			}
		}

		public string ConsumptionCheckpoint
		{
			get
			{
				return consumptionCheckpoint;
			}
			set	
			{
				consumptionCheckpoint = value;
			}
		}

		public string BeginTimestamp
		{
			get
			{
				return beginTimestamp;
			}
			set	
			{
				beginTimestamp = value;
			}
		}

		public string EndTimestamp
		{
			get
			{
				return endTimestamp;
			}
			set	
			{
				endTimestamp = value;
			}
		}

		public string ConsumptionClient
		{
			get
			{
				return consumptionClient;
			}
			set	
			{
				consumptionClient = value;
			}
		}

		public List<DescribeSubscriptionInstanceStatus_SynchronousObject> SubscriptionObject
		{
			get
			{
				return subscriptionObject;
			}
			set	
			{
				subscriptionObject = value;
			}
		}

		public DescribeSubscriptionInstanceStatus_SourceEndpoint SourceEndpoint
		{
			get
			{
				return sourceEndpoint;
			}
			set	
			{
				sourceEndpoint = value;
			}
		}

		public DescribeSubscriptionInstanceStatus_SubscriptionDataType SubscriptionDataType
		{
			get
			{
				return subscriptionDataType;
			}
			set	
			{
				subscriptionDataType = value;
			}
		}

		public class DescribeSubscriptionInstanceStatus_SynchronousObject
		{

			private string databaseName;

			private string wholeDatabase;

			private List<string> tableList;

			public string DatabaseName
			{
				get
				{
					return databaseName;
				}
				set	
				{
					databaseName = value;
				}
			}

			public string WholeDatabase
			{
				get
				{
					return wholeDatabase;
				}
				set	
				{
					wholeDatabase = value;
				}
			}

			public List<string> TableList
			{
				get
				{
					return tableList;
				}
				set	
				{
					tableList = value;
				}
			}
		}

		public class DescribeSubscriptionInstanceStatus_SourceEndpoint
		{

			private string instanceID;

			private string instanceType;

			public string InstanceID
			{
				get
				{
					return instanceID;
				}
				set	
				{
					instanceID = value;
				}
			}

			public string InstanceType
			{
				get
				{
					return instanceType;
				}
				set	
				{
					instanceType = value;
				}
			}
		}

		public class DescribeSubscriptionInstanceStatus_SubscriptionDataType
		{

			private bool? dDL;

			private bool? dML;

			public bool? DDL
			{
				get
				{
					return dDL;
				}
				set	
				{
					dDL = value;
				}
			}

			public bool? DML
			{
				get
				{
					return dML;
				}
				set	
				{
					dML = value;
				}
			}
		}
	}
}