/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeInitializationStatusResponseUnmarshaller
    {
        public static DescribeInitializationStatusResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeInitializationStatusResponse describeInitializationStatusResponse = new DescribeInitializationStatusResponse();

			describeInitializationStatusResponse.HttpResponse = context.HttpResponse;

			List<DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail> describeInitializationStatusResponse_structureInitializationDetails = new List<DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail>();
			for (int i = 0; i < context.Length("DescribeInitializationStatus.StructureInitializationDetails.Length"); i++) {
				DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail structureInitializationDetail = new DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail();
				structureInitializationDetail.ObjectName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].ObjectName");
				structureInitializationDetail.ObjectType = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].ObjectType");
				structureInitializationDetail.SourceOwnerDBName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].SourceOwnerDBName");
				structureInitializationDetail.DestinationOwnerDBName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].DestinationOwnerDBName");
				structureInitializationDetail.Status = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Status");
				structureInitializationDetail.ErrorMessage = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].ErrorMessage");
				structureInitializationDetail.ObjectDefinition = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].ObjectDefinition");

				List<DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail.DescribeInitializationStatus_StructureInitializationDetail1> structureInitializationDetail_constraints = new List<DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail.DescribeInitializationStatus_StructureInitializationDetail1>();
				for (int j = 0; j < context.Length("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints.Length"); j++) {
					DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail.DescribeInitializationStatus_StructureInitializationDetail1 structureInitializationDetail1 = new DescribeInitializationStatusResponse.DescribeInitializationStatus_StructureInitializationDetail.DescribeInitializationStatus_StructureInitializationDetail1();
					structureInitializationDetail1.ObjectName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].ObjectName");
					structureInitializationDetail1.ObjectType = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].ObjectType");
					structureInitializationDetail1.SourceOwnerDBName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].SourceOwnerDBName");
					structureInitializationDetail1.DestinationOwnerDBName = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].DestinationOwnerDBName");
					structureInitializationDetail1.Status = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].Status");
					structureInitializationDetail1.ErrorMessage = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].ErrorMessage");
					structureInitializationDetail1.ObjectDefinition = context.StringValue("DescribeInitializationStatus.StructureInitializationDetails["+ i +"].Constraints["+ j +"].ObjectDefinition");

					structureInitializationDetail_constraints.Add(structureInitializationDetail1);
				}
				structureInitializationDetail.Constraints = structureInitializationDetail_constraints;

				describeInitializationStatusResponse_structureInitializationDetails.Add(structureInitializationDetail);
			}
			describeInitializationStatusResponse.StructureInitializationDetails = describeInitializationStatusResponse_structureInitializationDetails;

			List<DescribeInitializationStatusResponse.DescribeInitializationStatus_DataInitializationDetail> describeInitializationStatusResponse_dataInitializationDetails = new List<DescribeInitializationStatusResponse.DescribeInitializationStatus_DataInitializationDetail>();
			for (int i = 0; i < context.Length("DescribeInitializationStatus.DataInitializationDetails.Length"); i++) {
				DescribeInitializationStatusResponse.DescribeInitializationStatus_DataInitializationDetail dataInitializationDetail = new DescribeInitializationStatusResponse.DescribeInitializationStatus_DataInitializationDetail();
				dataInitializationDetail.TableName = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].TableName");
				dataInitializationDetail.SourceOwnerDBName = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].SourceOwnerDBName");
				dataInitializationDetail.DestinationOwnerDBName = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].DestinationOwnerDBName");
				dataInitializationDetail.Status = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].Status");
				dataInitializationDetail.ErrorMessage = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].ErrorMessage");
				dataInitializationDetail.TotalRowNum = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].TotalRowNum");
				dataInitializationDetail.FinishRowNum = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].FinishRowNum");
				dataInitializationDetail.UsedTime = context.StringValue("DescribeInitializationStatus.DataInitializationDetails["+ i +"].UsedTime");

				describeInitializationStatusResponse_dataInitializationDetails.Add(dataInitializationDetail);
			}
			describeInitializationStatusResponse.DataInitializationDetails = describeInitializationStatusResponse_dataInitializationDetails;

			List<DescribeInitializationStatusResponse.DescribeInitializationStatus_DataSynchronizationDetail> describeInitializationStatusResponse_dataSynchronizationDetails = new List<DescribeInitializationStatusResponse.DescribeInitializationStatus_DataSynchronizationDetail>();
			for (int i = 0; i < context.Length("DescribeInitializationStatus.DataSynchronizationDetails.Length"); i++) {
				DescribeInitializationStatusResponse.DescribeInitializationStatus_DataSynchronizationDetail dataSynchronizationDetail = new DescribeInitializationStatusResponse.DescribeInitializationStatus_DataSynchronizationDetail();
				dataSynchronizationDetail.TableName = context.StringValue("DescribeInitializationStatus.DataSynchronizationDetails["+ i +"].TableName");
				dataSynchronizationDetail.SourceOwnerDBName = context.StringValue("DescribeInitializationStatus.DataSynchronizationDetails["+ i +"].SourceOwnerDBName");
				dataSynchronizationDetail.DestinationOwnerDBName = context.StringValue("DescribeInitializationStatus.DataSynchronizationDetails["+ i +"].DestinationOwnerDBName");
				dataSynchronizationDetail.Status = context.StringValue("DescribeInitializationStatus.DataSynchronizationDetails["+ i +"].Status");
				dataSynchronizationDetail.ErrorMessage = context.StringValue("DescribeInitializationStatus.DataSynchronizationDetails["+ i +"].ErrorMessage");

				describeInitializationStatusResponse_dataSynchronizationDetails.Add(dataSynchronizationDetail);
			}
			describeInitializationStatusResponse.DataSynchronizationDetails = describeInitializationStatusResponse_dataSynchronizationDetails;
        
			return describeInitializationStatusResponse;
        }
    }
}