/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeSubscriptionInstanceStatusResponseUnmarshaller
    {
        public static DescribeSubscriptionInstanceStatusResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeSubscriptionInstanceStatusResponse describeSubscriptionInstanceStatusResponse = new DescribeSubscriptionInstanceStatusResponse();

			describeSubscriptionInstanceStatusResponse.HttpResponse = context.HttpResponse;
			describeSubscriptionInstanceStatusResponse.SubscriptionInstanceID = context.StringValue("DescribeSubscriptionInstanceStatus.SubscriptionInstanceID");
			describeSubscriptionInstanceStatusResponse.SubscriptionInstanceName = context.StringValue("DescribeSubscriptionInstanceStatus.SubscriptionInstanceName");
			describeSubscriptionInstanceStatusResponse.PayType = context.StringValue("DescribeSubscriptionInstanceStatus.PayType");
			describeSubscriptionInstanceStatusResponse.Status = context.StringValue("DescribeSubscriptionInstanceStatus.Status");
			describeSubscriptionInstanceStatusResponse.ErrorMessage = context.StringValue("DescribeSubscriptionInstanceStatus.ErrorMessage");
			describeSubscriptionInstanceStatusResponse.ConsumptionCheckpoint = context.StringValue("DescribeSubscriptionInstanceStatus.ConsumptionCheckpoint");
			describeSubscriptionInstanceStatusResponse.BeginTimestamp = context.StringValue("DescribeSubscriptionInstanceStatus.BeginTimestamp");
			describeSubscriptionInstanceStatusResponse.EndTimestamp = context.StringValue("DescribeSubscriptionInstanceStatus.EndTimestamp");
			describeSubscriptionInstanceStatusResponse.ConsumptionClient = context.StringValue("DescribeSubscriptionInstanceStatus.ConsumptionClient");

			DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SourceEndpoint sourceEndpoint = new DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SourceEndpoint();
			sourceEndpoint.InstanceID = context.StringValue("DescribeSubscriptionInstanceStatus.SourceEndpoint.InstanceID");
			sourceEndpoint.InstanceType = context.StringValue("DescribeSubscriptionInstanceStatus.SourceEndpoint.InstanceType");
			describeSubscriptionInstanceStatusResponse.SourceEndpoint = sourceEndpoint;

			DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SubscriptionDataType subscriptionDataType = new DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SubscriptionDataType();
			subscriptionDataType.DDL = context.BooleanValue("DescribeSubscriptionInstanceStatus.SubscriptionDataType.DDL");
			subscriptionDataType.DML = context.BooleanValue("DescribeSubscriptionInstanceStatus.SubscriptionDataType.DML");
			describeSubscriptionInstanceStatusResponse.SubscriptionDataType = subscriptionDataType;

			List<DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SynchronousObject> describeSubscriptionInstanceStatusResponse_subscriptionObject = new List<DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SynchronousObject>();
			for (int i = 0; i < context.Length("DescribeSubscriptionInstanceStatus.SubscriptionObject.Length"); i++) {
				DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SynchronousObject synchronousObject = new DescribeSubscriptionInstanceStatusResponse.DescribeSubscriptionInstanceStatus_SynchronousObject();
				synchronousObject.DatabaseName = context.StringValue("DescribeSubscriptionInstanceStatus.SubscriptionObject["+ i +"].DatabaseName");
				synchronousObject.WholeDatabase = context.StringValue("DescribeSubscriptionInstanceStatus.SubscriptionObject["+ i +"].WholeDatabase");

				List<string> synchronousObject_tableList = new List<string>();
				for (int j = 0; j < context.Length("DescribeSubscriptionInstanceStatus.SubscriptionObject["+ i +"].TableList.Length"); j++) {
					synchronousObject_tableList.Add(context.StringValue("DescribeSubscriptionInstanceStatus.SubscriptionObject["+ i +"].TableList["+ j +"]"));
				}
				synchronousObject.TableList = synchronousObject_tableList;

				describeSubscriptionInstanceStatusResponse_subscriptionObject.Add(synchronousObject);
			}
			describeSubscriptionInstanceStatusResponse.SubscriptionObject = describeSubscriptionInstanceStatusResponse_subscriptionObject;
        
			return describeSubscriptionInstanceStatusResponse;
        }
    }
}