/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeSynchronizationJobStatusResponseUnmarshaller
    {
        public static DescribeSynchronizationJobStatusResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeSynchronizationJobStatusResponse describeSynchronizationJobStatusResponse = new DescribeSynchronizationJobStatusResponse();

			describeSynchronizationJobStatusResponse.HttpResponse = context.HttpResponse;
			describeSynchronizationJobStatusResponse.RequestId = context.StringValue("DescribeSynchronizationJobStatus.RequestId");
			describeSynchronizationJobStatusResponse.SynchronizationJobId = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationJobId");
			describeSynchronizationJobStatusResponse.SynchronizationJobName = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationJobName");
			describeSynchronizationJobStatusResponse.SynchronizationJobClass = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationJobClass");
			describeSynchronizationJobStatusResponse.PayType = context.StringValue("DescribeSynchronizationJobStatus.PayType");
			describeSynchronizationJobStatusResponse.ExpireTime = context.StringValue("DescribeSynchronizationJobStatus.ExpireTime");
			describeSynchronizationJobStatusResponse.StructureInitialization = context.StringValue("DescribeSynchronizationJobStatus.StructureInitialization");
			describeSynchronizationJobStatusResponse.DataInitialization = context.StringValue("DescribeSynchronizationJobStatus.DataInitialization");
			describeSynchronizationJobStatusResponse.Status = context.StringValue("DescribeSynchronizationJobStatus.Status");
			describeSynchronizationJobStatusResponse.ErrorMessage = context.StringValue("DescribeSynchronizationJobStatus.ErrorMessage");
			describeSynchronizationJobStatusResponse.Delay = context.StringValue("DescribeSynchronizationJobStatus.Delay");

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SourceEndpoint sourceEndpoint = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SourceEndpoint();
			sourceEndpoint.InstanceType = context.StringValue("DescribeSynchronizationJobStatus.SourceEndpoint.InstanceType");
			sourceEndpoint.InstanceId = context.StringValue("DescribeSynchronizationJobStatus.SourceEndpoint.InstanceId");
			describeSynchronizationJobStatusResponse.SourceEndpoint = sourceEndpoint;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DestinationEndpoint destinationEndpoint = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DestinationEndpoint();
			destinationEndpoint.InstanceType = context.StringValue("DescribeSynchronizationJobStatus.DestinationEndpoint.InstanceType");
			destinationEndpoint.InstanceId = context.StringValue("DescribeSynchronizationJobStatus.DestinationEndpoint.InstanceId");
			describeSynchronizationJobStatusResponse.DestinationEndpoint = destinationEndpoint;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus precheckStatus = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus();
			precheckStatus.Status = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Status");
			precheckStatus.Percent = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Percent");

			List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus.DescribeSynchronizationJobStatus_CheckItem> precheckStatus_detail = new List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus.DescribeSynchronizationJobStatus_CheckItem>();
			for (int i = 0; i < context.Length("DescribeSynchronizationJobStatus.PrecheckStatus.Detail.Length"); i++) {
				DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus.DescribeSynchronizationJobStatus_CheckItem checkItem = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_PrecheckStatus.DescribeSynchronizationJobStatus_CheckItem();
				checkItem.ItemName = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Detail["+ i +"].ItemName");
				checkItem.CheckStatus = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Detail["+ i +"].CheckStatus");
				checkItem.ErrorMessage = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Detail["+ i +"].ErrorMessage");
				checkItem.RepairMethod = context.StringValue("DescribeSynchronizationJobStatus.PrecheckStatus.Detail["+ i +"].RepairMethod");

				precheckStatus_detail.Add(checkItem);
			}
			precheckStatus.Detail = precheckStatus_detail;
			describeSynchronizationJobStatusResponse.PrecheckStatus = precheckStatus;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_StructureInitializationStatus structureInitializationStatus = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_StructureInitializationStatus();
			structureInitializationStatus.Status = context.StringValue("DescribeSynchronizationJobStatus.StructureInitializationStatus.Status");
			structureInitializationStatus.Percent = context.StringValue("DescribeSynchronizationJobStatus.StructureInitializationStatus.Percent");
			structureInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobStatus.StructureInitializationStatus.ErrorMessage");
			structureInitializationStatus.Progress = context.StringValue("DescribeSynchronizationJobStatus.StructureInitializationStatus.Progress");
			describeSynchronizationJobStatusResponse.StructureInitializationStatus = structureInitializationStatus;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DataInitializationStatus dataInitializationStatus = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DataInitializationStatus();
			dataInitializationStatus.Status = context.StringValue("DescribeSynchronizationJobStatus.DataInitializationStatus.Status");
			dataInitializationStatus.Percent = context.StringValue("DescribeSynchronizationJobStatus.DataInitializationStatus.Percent");
			dataInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobStatus.DataInitializationStatus.ErrorMessage");
			dataInitializationStatus.Progress = context.StringValue("DescribeSynchronizationJobStatus.DataInitializationStatus.Progress");
			describeSynchronizationJobStatusResponse.DataInitializationStatus = dataInitializationStatus;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DataSynchronizationStatus dataSynchronizationStatus = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_DataSynchronizationStatus();
			dataSynchronizationStatus.Status = context.StringValue("DescribeSynchronizationJobStatus.DataSynchronizationStatus.Status");
			dataSynchronizationStatus.Percent = context.StringValue("DescribeSynchronizationJobStatus.DataSynchronizationStatus.Percent");
			dataSynchronizationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobStatus.DataSynchronizationStatus.ErrorMessage");
			dataSynchronizationStatus.Delay = context.StringValue("DescribeSynchronizationJobStatus.DataSynchronizationStatus.Delay");
			describeSynchronizationJobStatusResponse.DataSynchronizationStatus = dataSynchronizationStatus;

			DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_Performance performance = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_Performance();
			performance.RPS = context.StringValue("DescribeSynchronizationJobStatus.Performance.RPS");
			performance.FLOW = context.StringValue("DescribeSynchronizationJobStatus.Performance.FLOW");
			describeSynchronizationJobStatusResponse.Performance = performance;

			List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject> describeSynchronizationJobStatusResponse_synchronizationObjects = new List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject>();
			for (int i = 0; i < context.Length("DescribeSynchronizationJobStatus.SynchronizationObjects.Length"); i++) {
				DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject synchronizationObject = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject();
				synchronizationObject.SchemaName = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].SchemaName");
				synchronizationObject.NewSchemaName = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].NewSchemaName");

				List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableInclude> synchronizationObject_tableIncludes = new List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableInclude>();
				for (int j = 0; j < context.Length("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].TableIncludes.Length"); j++) {
					DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableInclude tableInclude = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableInclude();
					tableInclude.TableName = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].TableIncludes["+ j +"].TableName");

					synchronizationObject_tableIncludes.Add(tableInclude);
				}
				synchronizationObject.TableIncludes = synchronizationObject_tableIncludes;

				List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableExclude> synchronizationObject_tableExcludes = new List<DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableExclude>();
				for (int j = 0; j < context.Length("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].TableExcludes.Length"); j++) {
					DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableExclude tableExclude = new DescribeSynchronizationJobStatusResponse.DescribeSynchronizationJobStatus_SynchronizationObject.DescribeSynchronizationJobStatus_TableExclude();
					tableExclude.TableName = context.StringValue("DescribeSynchronizationJobStatus.SynchronizationObjects["+ i +"].TableExcludes["+ j +"].TableName");

					synchronizationObject_tableExcludes.Add(tableExclude);
				}
				synchronizationObject.TableExcludes = synchronizationObject_tableExcludes;

				describeSynchronizationJobStatusResponse_synchronizationObjects.Add(synchronizationObject);
			}
			describeSynchronizationJobStatusResponse.SynchronizationObjects = describeSynchronizationJobStatusResponse_synchronizationObjects;
        
			return describeSynchronizationJobStatusResponse;
        }
    }
}