/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
using Aliyun.Acs.Core.Transform;
using Aliyun.Acs.Dts.Model.V20160801;
using System;
using System.Collections.Generic;

namespace Aliyun.Acs.Dts.Transform.V20160801
{
    public class DescribeSynchronizationJobsResponseUnmarshaller
    {
        public static DescribeSynchronizationJobsResponse Unmarshall(UnmarshallerContext context)
        {
			DescribeSynchronizationJobsResponse describeSynchronizationJobsResponse = new DescribeSynchronizationJobsResponse();

			describeSynchronizationJobsResponse.HttpResponse = context.HttpResponse;
			describeSynchronizationJobsResponse.RequestId = context.StringValue("DescribeSynchronizationJobs.RequestId");
			describeSynchronizationJobsResponse.PageNumber = context.IntegerValue("DescribeSynchronizationJobs.PageNumber");
			describeSynchronizationJobsResponse.TotalRecordCount = context.LongValue("DescribeSynchronizationJobs.TotalRecordCount");
			describeSynchronizationJobsResponse.PageRecordCount = context.IntegerValue("DescribeSynchronizationJobs.PageRecordCount");

			List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance> describeSynchronizationJobsResponse_synchronizationInstances = new List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance>();
			for (int i = 0; i < context.Length("DescribeSynchronizationJobs.SynchronizationInstances.Length"); i++) {
				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance synchronizationInstance = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance();
				synchronizationInstance.SynchronizationJobId = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationJobId");
				synchronizationInstance.SynchronizationJobName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationJobName");
				synchronizationInstance.SynchronizationJobClass = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationJobClass");
				synchronizationInstance.PayType = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PayType");
				synchronizationInstance.ExpireTime = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].ExpireTime");
				synchronizationInstance.StructureInitialization = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].StructureInitialization");
				synchronizationInstance.DataInitialization = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataInitialization");
				synchronizationInstance.Status = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].Status");
				synchronizationInstance.ErrorMessage = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].ErrorMessage");
				synchronizationInstance.Delay = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].Delay");

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SourceEndpoint sourceEndpoint = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SourceEndpoint();
				sourceEndpoint.InstanceType = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SourceEndpoint.InstanceType");
				sourceEndpoint.InstanceId = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SourceEndpoint.InstanceId");
				synchronizationInstance.SourceEndpoint = sourceEndpoint;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DestinationEndpoint destinationEndpoint = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DestinationEndpoint();
				destinationEndpoint.InstanceType = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DestinationEndpoint.InstanceType");
				destinationEndpoint.InstanceId = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DestinationEndpoint.InstanceId");
				synchronizationInstance.DestinationEndpoint = destinationEndpoint;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus precheckStatus = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus();
				precheckStatus.Status = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Status");
				precheckStatus.Percent = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Percent");

				List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus.DescribeSynchronizationJobs_CheckItem> precheckStatus_detail = new List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus.DescribeSynchronizationJobs_CheckItem>();
				for (int j = 0; j < context.Length("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Detail.Length"); j++) {
					DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus.DescribeSynchronizationJobs_CheckItem checkItem = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_PrecheckStatus.DescribeSynchronizationJobs_CheckItem();
					checkItem.ItemName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Detail["+ j +"].ItemName");
					checkItem.CheckStatus = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Detail["+ j +"].CheckStatus");
					checkItem.ErrorMessage = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Detail["+ j +"].ErrorMessage");
					checkItem.RepairMethod = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].PrecheckStatus.Detail["+ j +"].RepairMethod");

					precheckStatus_detail.Add(checkItem);
				}
				precheckStatus.Detail = precheckStatus_detail;
				synchronizationInstance.PrecheckStatus = precheckStatus;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_StructureInitializationStatus structureInitializationStatus = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_StructureInitializationStatus();
				structureInitializationStatus.Status = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].StructureInitializationStatus.Status");
				structureInitializationStatus.Percent = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].StructureInitializationStatus.Percent");
				structureInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].StructureInitializationStatus.ErrorMessage");
				structureInitializationStatus.Progress = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].StructureInitializationStatus.Progress");
				synchronizationInstance.StructureInitializationStatus = structureInitializationStatus;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DataInitializationStatus dataInitializationStatus = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DataInitializationStatus();
				dataInitializationStatus.Status = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataInitializationStatus.Status");
				dataInitializationStatus.Percent = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataInitializationStatus.Percent");
				dataInitializationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataInitializationStatus.ErrorMessage");
				dataInitializationStatus.Progress = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataInitializationStatus.Progress");
				synchronizationInstance.DataInitializationStatus = dataInitializationStatus;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DataSynchronizationStatus dataSynchronizationStatus = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_DataSynchronizationStatus();
				dataSynchronizationStatus.Status = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataSynchronizationStatus.Status");
				dataSynchronizationStatus.Percent = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataSynchronizationStatus.Percent");
				dataSynchronizationStatus.ErrorMessage = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataSynchronizationStatus.ErrorMessage");
				dataSynchronizationStatus.Delay = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].DataSynchronizationStatus.Delay");
				synchronizationInstance.DataSynchronizationStatus = dataSynchronizationStatus;

				DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_Performance performance = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_Performance();
				performance.RPS = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].Performance.RPS");
				performance.FLOW = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].Performance.FLOW");
				synchronizationInstance.Performance = performance;

				List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject> synchronizationInstance_synchronizationObjects = new List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject>();
				for (int j = 0; j < context.Length("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects.Length"); j++) {
					DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject synchronizationObject = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject();
					synchronizationObject.SchemaName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].SchemaName");
					synchronizationObject.NewSchemaName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].NewSchemaName");

					List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableInclude> synchronizationObject_tableIncludes = new List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableInclude>();
					for (int k = 0; k < context.Length("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].TableIncludes.Length"); k++) {
						DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableInclude tableInclude = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableInclude();
						tableInclude.TableName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].TableIncludes["+ k +"].TableName");

						synchronizationObject_tableIncludes.Add(tableInclude);
					}
					synchronizationObject.TableIncludes = synchronizationObject_tableIncludes;

					List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableExclude> synchronizationObject_tableExcludes = new List<DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableExclude>();
					for (int k = 0; k < context.Length("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].TableExcludes.Length"); k++) {
						DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableExclude tableExclude = new DescribeSynchronizationJobsResponse.DescribeSynchronizationJobs_SynchronizationInstance.DescribeSynchronizationJobs_SynchronizationObject.DescribeSynchronizationJobs_TableExclude();
						tableExclude.TableName = context.StringValue("DescribeSynchronizationJobs.SynchronizationInstances["+ i +"].SynchronizationObjects["+ j +"].TableExcludes["+ k +"].TableName");

						synchronizationObject_tableExcludes.Add(tableExclude);
					}
					synchronizationObject.TableExcludes = synchronizationObject_tableExcludes;

					synchronizationInstance_synchronizationObjects.Add(synchronizationObject);
				}
				synchronizationInstance.SynchronizationObjects = synchronizationInstance_synchronizationObjects;

				describeSynchronizationJobsResponse_synchronizationInstances.Add(synchronizationInstance);
			}
			describeSynchronizationJobsResponse.SynchronizationInstances = describeSynchronizationJobsResponse_synchronizationInstances;
        
			return describeSynchronizationJobsResponse;
        }
    }
}